#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1476103983.930497
__CHEETAH_genTimestamp__ = 'Mon Oct 10 14:53:03 2016'
__CHEETAH_src__ = 'templates/concdesc.tmpl'
__CHEETAH_srcLastModified__ = 'Fri Aug  5 13:25:55 2016'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class concdesc(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(concdesc, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def title(self, **KWS):



        ## CHEETAH: generated from #def title at line 3, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def main(self, **KWS):



        ## CHEETAH: generated from #block main at line 6, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_29397306 = _filter
        filterName = u'WebSafe'
        if self._CHEETAH__filters.has_key("WebSafe"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''<h3>''')
        if False:
            _("Concordance description")
        _v = VFFSL(SL,"_",False)("Concordance description") # u'$_("Concordance description")' on line 8, col 5
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Concordance description")')) # from line 8, col 5.
        write(u'''</h3>

<p>''')
        if False:
            _("Corpus")
        _v = VFFSL(SL,"_",False)("Corpus") # u'$_("Corpus")' on line 10, col 4
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Corpus")')) # from line 10, col 4.
        write(u''': <b>''')
        _v = VFFSL(SL,"corp_full_name",True) # u'$corp_full_name' on line 10, col 21
        if _v is not None: write(_filter(_v, rawExpr=u'$corp_full_name')) # from line 10, col 21.
        write(u'''</b>
''')
        if VFFSL(SL,"usesubcorp",True): # generated from line 11, col 1
            if False:
                _("Subcorpus")
            _v = VFFSL(SL,"_",False)("Subcorpus") # u'$_("Subcorpus")' on line 12, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$_("Subcorpus")')) # from line 12, col 1.
            write(u''': <b>''')
            _v = VFFSL(SL,"usesubcorp",True) # u'$usesubcorp' on line 12, col 21
            if _v is not None: write(_filter(_v, rawExpr=u'$usesubcorp')) # from line 12, col 21.
            write(u'''
''')
            if VFFSL(SL,"complement_subc",True): # generated from line 13, col 1
                write(u''' ''')
                if False:
                    _('-- the rest of the corpus')
                _v = VFFSL(SL,"_",False)('-- the rest of the corpus') # u"$_('-- the rest of the corpus')" on line 13, col 23
                if _v is not None: write(_filter(_v, rawExpr=u"$_('-- the rest of the corpus')")) # from line 13, col 23.
                write(u''' ''')
            write(u''' </b>
''')
        write(u'''</p>

<table class="data" id="concdesc">
<thead>
  <tr>
    <th>''')
        if False:
            _("Operation")
        _v = VFFSL(SL,"_",False)("Operation") # u'$_("Operation")' on line 20, col 9
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Operation")')) # from line 20, col 9.
        write(u'''</th>
    <th>''')
        if False:
            _("Parameters")
        _v = VFFSL(SL,"_",False)("Parameters") # u'$_("Parameters")' on line 21, col 9
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Parameters")')) # from line 21, col 9.
        write(u'''</th>
    <th>''')
        if False:
            _("Hits")
        _v = VFFSL(SL,"_",False)("Hits") # u'$_("Hits")' on line 22, col 9
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Hits")')) # from line 22, col 9.
        write(u'''</th>
  </tr>
</thead>
<tbody>
''')
        for d in VFFSL(SL,"Desc",True): # generated from line 26, col 1
            write(u'''  <tr>
    <td>''')
            _v = VFFSL(SL,"d.op",True) # u'$d.op' on line 28, col 9
            if _v is not None: write(_filter(_v, rawExpr=u'$d.op')) # from line 28, col 9.
            write(u'''
    </td><td>
''')
            if VFFSL(SL,"d.da",True): # generated from line 30, col 5
                write(u'''      <span title="Default attribute" class="da">''')
                _v = VFFSL(SL,"d.da",True) # u'$d.da' on line 31, col 50
                if _v is not None: write(_filter(_v, rawExpr=u'$d.da')) # from line 31, col 50.
                write(u'''</span>
''')
            if VFFSL(SL,"d.churl",True): # generated from line 33, col 5
                write(u'''      <a href="''')
                _v = VFFSL(SL,"d.formname",True) # u'$d.formname' on line 34, col 16
                if _v is not None: write(_filter(_v, rawExpr=u'$d.formname')) # from line 34, col 16.
                write(u'''?''')
                _v = VFFSL(SL,"d.churl",True) # u'$d.churl' on line 34, col 28
                if _v is not None: write(_filter(_v, rawExpr=u'$d.churl')) # from line 34, col 28.
                write(u''';''')
                _v = VFFSL(SL,"globals",True) # u'$globals' on line 34, col 37
                if _v is not None: write(_filter(_v, rawExpr=u'$globals')) # from line 34, col 37.
                write(u'''">
''')
            write(u'''    ''')
            _v = VFFSL(SL,"d.arg",True) # u'$d.arg' on line 36, col 5
            if _v is not None: write(_filter(_v, rawExpr=u'$d.arg')) # from line 36, col 5.
            write(u'''
''')
            if VFFSL(SL,"d.churl",True): # generated from line 37, col 5
                write(u'''      </a>
''')
            write(u'''    </td><td align="right">
     <a href="view?''')
            _v = VFFSL(SL,"d.tourl",True) # u'$d.tourl' on line 41, col 20
            if _v is not None: write(_filter(_v, rawExpr=u'$d.tourl')) # from line 41, col 20.
            write(u''';''')
            _v = VFFSL(SL,"globals",True) # u'$globals' on line 41, col 29
            if _v is not None: write(_filter(_v, rawExpr=u'$globals')) # from line 41, col 29.
            write(u'''">''')
            _v = VFFSL(SL,"d.size",True) # u'$d.size' on line 41, col 39
            if _v is not None: write(_filter(_v, rawExpr=u'$d.size')) # from line 41, col 39.
            write(u'''</a>
    </td>
  </tr>
''')
        write(u'''</tbody></table>
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_29397306
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        #  Copyright (c) 2003-2013  Pavel Rychly, Vojtech Kovar, Milos Jakubicek, Milos Husak, Vit Baisa
        write(u'''

''')
        self.main(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_concdesc= 'respond'

## END CLASS DEFINITION

if not hasattr(concdesc, '_initCheetahAttributes'):
    templateAPIClass = getattr(concdesc, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(concdesc)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=concdesc()).run()


