#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1476103983.681465
__CHEETAH_genTimestamp__ = 'Mon Oct 10 14:53:03 2016'
__CHEETAH_src__ = 'templates/fcs.tmpl'
__CHEETAH_srcLastModified__ = 'Wed Jan 20 17:24:23 2016'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class fcs(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(fcs, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def print_error(self, c, d, m, **KWS):



        ## CHEETAH: generated from #def print_error($c, $d, $m) at line 11, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''<sru:diagnostics xmlns:diag="http://www.loc.gov/zing/srw/diagnostic/">
        <diag:diagnostic>
            <diag:uri>info:srw/diagnostic/1/''')
        _v = VFFSL(SL,"c",True) # u'$c' on line 14, col 45
        if _v is not None: write(_filter(_v, rawExpr=u'$c')) # from line 14, col 45.
        write(u'''</diag:uri>
            <diag:details>''')
        _v = VFFSL(SL,"d",True) # u'$d' on line 15, col 27
        if _v is not None: write(_filter(_v, rawExpr=u'$d')) # from line 15, col 27.
        write(u'''</diag:details>
            <diag:message>''')
        _v = VFFSL(SL,"m",True) # u'$m' on line 16, col 27
        if _v is not None: write(_filter(_v, rawExpr=u'$m')) # from line 16, col 27.
        write(u'''</diag:message>
        </diag:diagnostic>
    </sru:diagnostics>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def main(self, **KWS):



        ## CHEETAH: generated from #def main at line 21, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u"""<?xml version='1.0' encoding='utf-8'?>
""")
        if VFFSL(SL,"xml_stylesheet",True): # generated from line 23, col 1
            write(u'''<?xml-stylesheet href="''')
            _v = VFFSL(SL,"xml_stylesheet",True) # u'$xml_stylesheet' on line 24, col 24
            if _v is not None: write(_filter(_v, rawExpr=u'$xml_stylesheet')) # from line 24, col 24.
            write(u'''" type="text/xsl"?>
''')
        #  explain = show attribute list of Brown corpus
        if VFFSL(SL,"operation",True) == 'explain': # generated from line 27, col 1
            write(u'''<sru:explainResponse xmlns:sru="http://www.loc.gov/zing/srw/">
    <sru:version>''')
            _v = VFFSL(SL,"version",True) # u'$version' on line 29, col 18
            if _v is not None: write(_filter(_v, rawExpr=u'$version')) # from line 29, col 18.
            write(u'''</sru:version>
    <sru:record>
        <sru:recordSchema>http://explain.z3950.org/dtd/2.0/</sru:recordSchema>
        <sru:recordPacking>''')
            _v = VFFSL(SL,"recordPacking",True) # u'$recordPacking' on line 32, col 28
            if _v is not None: write(_filter(_v, rawExpr=u'$recordPacking')) # from line 32, col 28.
            write(u'''</sru:recordPacking>
        <sru:recordData>
            <zr:explain xmlns:zr="http://explain.z3950.org/dtd/2.0/">
                <zr:serverInfo protocol="SRU" version="''')
            _v = VFFSL(SL,"version",True) # u'$version' on line 35, col 56
            if _v is not None: write(_filter(_v, rawExpr=u'$version')) # from line 35, col 56.
            write(u'''" transport="http" method="GET POST SOAP">
                    <zr:host>''')
            _v = VFFSL(SL,"server_name",True) # u'$server_name' on line 36, col 30
            if _v is not None: write(_filter(_v, rawExpr=u'$server_name')) # from line 36, col 30.
            write(u'''</zr:host>
                    <zr:port>''')
            _v = VFFSL(SL,"server_port",True) # u'$server_port' on line 37, col 30
            if _v is not None: write(_filter(_v, rawExpr=u'$server_port')) # from line 37, col 30.
            write(u'''</zr:port>
                    <zr:database>''')
            _v = VFFSL(SL,"database",True) # u'$database' on line 38, col 34
            if _v is not None: write(_filter(_v, rawExpr=u'$database')) # from line 38, col 34.
            write(u'''</zr:database>
                    </zr:serverInfo>
                <zr:databaseInfo>
                    <zr:title lang="en" primary="true">Brown Corpus</zr:title>
                </zr:databaseInfo>
                <zr:indexInfo>
                    <zr:set identifier="clarin.eu/fcs/1.0" name="fcs">
                        <zr:title lang="de">CLARIN Content Search</zr:title>
                        <zr:title lang="en" primary="true">CLARIN Content Search</zr:title>
                    </zr:set>
''')
            for attr in VFFSL(SL,"result",True): # generated from line 48, col 5
                write(u'''                    <zr:index search="true" scan="true" sort="true">
                        <zr:title lang="en" primary="true">''')
                _v = VFFSL(SL,"attr",True) # u'$attr' on line 50, col 60
                if _v is not None: write(_filter(_v, rawExpr=u'$attr')) # from line 50, col 60.
                write(u'''</zr:title>
                        <zr:map primary="true">
                            <zr:name>''')
                _v = VFFSL(SL,"attr",True) # u'$attr' on line 52, col 38
                if _v is not None: write(_filter(_v, rawExpr=u'$attr')) # from line 52, col 38.
                write(u'''</zr:name>
                        </zr:map>
                    </zr:index>
''')
            write(u'''                </zr:indexInfo>
                <zr:schemaInfo>
                    <zr:schema identifier="http://clarin.eu/fcs/1.0" name="fcs">
                        <zr:title lang="en" primary="true">CLARIN Content Search</zr:title>
                    </zr:schema>
                </zr:schemaInfo>
                <zr:configInfo>
''')
            #                   <zr:default type="numberOfRecords">$numberOfRecords</zr:default>
            write(u'''                    <zr:setting type="maximumRecords">''')
            _v = VFFSL(SL,"maximumRecords",True) # u'$maximumRecords' on line 64, col 55
            if _v is not None: write(_filter(_v, rawExpr=u'$maximumRecords')) # from line 64, col 55.
            write(u'''</zr:setting>
                </zr:configInfo>
            </zr:explain>
        </sru:recordData>
    </sru:record>
''')
            if VFFSL(SL,"error",True): # generated from line 69, col 3
                write(u'''    ''')
                _v = VFFSL(SL,"print_error",False)(VFFSL(SL,"code",True), VFFSL(SL,"details",True), VFFSL(SL,"msg",True)) # u'$print_error($code, $details, $msg)' on line 70, col 5
                if _v is not None: write(_filter(_v, rawExpr=u'$print_error($code, $details, $msg)')) # from line 70, col 5.
                write(u'''
''')
            write(u'''</sru:explainResponse>
''')
            #  search = make concordance
        elif VFFSL(SL,"operation",True) == 'searchRetrieve': # generated from line 74, col 1
            write(u'''<sru:searchRetrieveResponse xmlns:sru="http://www.loc.gov/zing/srw/">
    <sru:version>''')
            _v = VFFSL(SL,"version",True) # u'$version' on line 76, col 18
            if _v is not None: write(_filter(_v, rawExpr=u'$version')) # from line 76, col 18.
            write(u'''</sru:version>
    <sru:numberOfRecords>''')
            _v = VFFSL(SL,"numberOfRecords",True) # u'$numberOfRecords' on line 77, col 26
            if _v is not None: write(_filter(_v, rawExpr=u'$numberOfRecords')) # from line 77, col 26.
            write(u'''</sru:numberOfRecords>
''')
            if VFFSL(SL,"numberOfRecords",True): # generated from line 78, col 5
                write(u'''    <sru:records>
        <sru:record>
            <sru:recordSchema>http://clarin.eu/fcs/1.0</sru:recordSchema>
            <sru:recordPacking>''')
                _v = VFFSL(SL,"recordPacking",True) # u'$recordPacking' on line 82, col 32
                if _v is not None: write(_filter(_v, rawExpr=u'$recordPacking')) # from line 82, col 32.
                write(u'''</sru:recordPacking>
            <sru:recordData>
                <fcs:Resource xmlns:fcs="http://clarin.eu/fcs/1.0" pid="brown" ref="brown">
                    <fcs:DataView type="application/x-clarin-fcs-kwic+xml">
''')
                for i, kwicline in VFFSL(SL,"enumerate",False)(VFFSL(SL,"result",True)): # generated from line 86, col 5
                    lc = VFFSL(SL,"kwicline",True)[0]
                    kwic = VFFSL(SL,"kwicline",True)[1]
                    rc = VFFSL(SL,"kwicline",True)[2]
                    ref = VFFSL(SL,"kwicline",True)[3]
                    write(u'''                        <kwic:kwic xmlns:kwic="http://clarin.eu/fcs/1.0/kwic">
                            <kwic:c type="left">''')
                    _v = VFFSL(SL,"lc",True) # u'$lc' on line 92, col 49
                    if _v is not None: write(_filter(_v, rawExpr=u'$lc')) # from line 92, col 49.
                    write(u'''</kwic:c>
                            <kwic:kw>''')
                    _v = VFFSL(SL,"kwic",True) # u'$kwic' on line 93, col 38
                    if _v is not None: write(_filter(_v, rawExpr=u'$kwic')) # from line 93, col 38.
                    write(u'''</kwic:kw>
                            <kwic:c type="right">''')
                    _v = VFFSL(SL,"rc",True) # u'$rc' on line 94, col 50
                    if _v is not None: write(_filter(_v, rawExpr=u'$rc')) # from line 94, col 50.
                    write(u'''</kwic:c>
                        </kwic:kwic>
''')
                write(u'''                    </fcs:DataView>
                </fcs:Resource>
            </sru:recordData>
''')
                #             <sru:recordPosition>$i</sru:recordPosition>
                write(u'''        </sru:record>
    </sru:records>
''')
            if VFFSL(SL,"error",True): # generated from line 104, col 3
                write(u'''    ''')
                _v = VFFSL(SL,"print_error",False)(VFFSL(SL,"code",True), VFFSL(SL,"details",True), VFFSL(SL,"msg",True)) # u'$print_error($code, $details, $msg)' on line 105, col 5
                if _v is not None: write(_filter(_v, rawExpr=u'$print_error($code, $details, $msg)')) # from line 105, col 5.
                write(u'''
''')
            write(u'''</sru:searchRetrieveResponse>
''')
            #  scan = wordlist
        elif VFFSL(SL,"operation",True) == 'scan': # generated from line 109, col 1
            write(u'''<sru:scanResponse xmlns:sru="http://www.loc.gov/zing/srw/">
    <sru:version>''')
            _v = VFFSL(SL,"version",True) # u'$version' on line 111, col 18
            if _v is not None: write(_filter(_v, rawExpr=u'$version')) # from line 111, col 18.
            write(u'''</sru:version>
''')
            if VFFSL(SL,"error",True): # generated from line 112, col 3
                write(u'''    ''')
                _v = VFFSL(SL,"print_error",False)(VFFSL(SL,"code",True), VFFSL(SL,"details",True), VFFSL(SL,"msg",True)) # u'$print_error($code, $details, $msg)' on line 113, col 5
                if _v is not None: write(_filter(_v, rawExpr=u'$print_error($code, $details, $msg)')) # from line 113, col 5.
                write(u'''
''')
            else: # generated from line 114, col 3
                if VFFSL(SL,"result",True): # generated from line 115, col 5
                    write(u'''    <sru:terms>
''')
                    for item, freq in VFFSL(SL,"result",True): # generated from line 117, col 5
                        write(u'''        <sru:term>
            <sru:value>''')
                        _v = VFFSL(SL,"item",True) # u'$item' on line 119, col 24
                        if _v is not None: write(_filter(_v, rawExpr=u'$item')) # from line 119, col 24.
                        write(u'''</sru:value>
            <sru:numberOfRecords>''')
                        _v = VFFSL(SL,"freq",True) # u'$freq' on line 120, col 34
                        if _v is not None: write(_filter(_v, rawExpr=u'$freq')) # from line 120, col 34.
                        write(u'''</sru:numberOfRecords>
            <sru:displayTerm>''')
                        _v = VFFSL(SL,"item",True) # u'$item' on line 121, col 30
                        if _v is not None: write(_filter(_v, rawExpr=u'$item')) # from line 121, col 30.
                        write(u'''</sru:displayTerm>
        </sru:term>
''')
                    write(u'''    </sru:terms>
''')
            write(u'''</sru:scanResponse>
''')
            #  scan fcs.resource = list of corpora
        elif VFFSL(SL,"operation",True) == 'fcs.resource': # generated from line 129, col 1
            write(u'''<sru:scanResponse xmlns:sru="http://www.loc.gov/zing/srw/">
    <sru:version>''')
            _v = VFFSL(SL,"version",True) # u'$version' on line 131, col 18
            if _v is not None: write(_filter(_v, rawExpr=u'$version')) # from line 131, col 18.
            write(u'''</sru:version>
''')
            if VFFSL(SL,"error",True): # generated from line 132, col 3
                write(u'''    ''')
                _v = VFFSL(SL,"print_error",False)(VFFSL(SL,"code",True), VFFSL(SL,"details",True), VFFSL(SL,"msg",True)) # u'$print_error($code, $details, $msg)' on line 133, col 5
                if _v is not None: write(_filter(_v, rawExpr=u'$print_error($code, $details, $msg)')) # from line 133, col 5.
                write(u'''
''')
            else: # generated from line 134, col 3
                write(u'''    <sru:terms>
''')
                for c in VFFSL(SL,"FCSCorpora",True): # generated from line 136, col 5
                    write(u'''        <sru:term>
            <sru:value>''')
                    _v = VFFSL(SL,"c.id",True) # u'$c.id' on line 138, col 24
                    if _v is not None: write(_filter(_v, rawExpr=u'$c.id')) # from line 138, col 24.
                    write(u'''</sru:value>
            <sru:displayTerm>''')
                    _v = VFFSL(SL,"c.name",True) # u'$c.name' on line 139, col 30
                    if _v is not None: write(_filter(_v, rawExpr=u'$c.name')) # from line 139, col 30.
                    write(u'''</sru:displayTerm>
''')
                    if VFFSL(SL,"resource_info",True): # generated from line 140, col 12
                        write(u'''            <sru:extraTermData><ResourceInfo xmlns="http://clarin.eu/fcs/1.0/resource-info" hasSubResources="false">
                  <Description xml:lang="en">''')
                        _v = VFFSL(SL,"c.description",True) # u'$c.description' on line 142, col 46
                        if _v is not None: write(_filter(_v, rawExpr=u'$c.description')) # from line 142, col 46.
                        write(u'''</Description>
                  <LandingPageURI>''')
                        _v = VFFSL(SL,"c.infohref",True) # u'$c.infohref' on line 143, col 35
                        if _v is not None: write(_filter(_v, rawExpr=u'$c.infohref')) # from line 143, col 35.
                        write(u'''</LandingPageURI>
                  <Languages><Language>''')
                        _v = VFFSL(SL,"c.language",True) # u'$c.language' on line 144, col 40
                        if _v is not None: write(_filter(_v, rawExpr=u'$c.language')) # from line 144, col 40.
                        write(u'''</Language></Languages>

            </ResourceInfo></sru:extraTermData>
''')
                    write(u'''        </sru:term>
''')
                write(u'''    </sru:terms>
''')
            write(u'''</sru:scanResponse>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        #  Copyright (c) 2013  Vit Baisa, Pavel Rychly
        # 
        if VFFSL(SL,"recordPacking",True) == 'string': # generated from line 3, col 1
            _orig_filter_57652009 = _filter
            filterName = u'WebSafe'
            if self._CHEETAH__filters.has_key("WebSafe"):
                _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
            else:
                _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
            _v = VFFSL(SL,"main",True) # u'$main' on line 5, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$main')) # from line 5, col 1.
            write(u'''
''')
            _filter = self._CHEETAH__currentFilter = _orig_filter_57652009
        else: # generated from line 7, col 1
            _v = VFFSL(SL,"main",True) # u'$main' on line 8, col 1
            if _v is not None: write(_filter(_v, rawExpr=u'$main')) # from line 8, col 1.
            write(u'''
''')
        # 
        # 
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_fcs= 'respond'

## END CLASS DEFINITION

if not hasattr(fcs, '_initCheetahAttributes'):
    templateAPIClass = getattr(fcs, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(fcs)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=fcs()).run()


