#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1476103983.227003
__CHEETAH_genTimestamp__ = 'Mon Oct 10 14:53:03 2016'
__CHEETAH_src__ = 'templates/fullref.tmpl'
__CHEETAH_srcLastModified__ = 'Wed Jan 20 17:24:23 2016'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class fullref(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(fullref, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        #  Copyright (c) 2003-2013  Pavel Rychly, Vojtech Kovar, Milos Jakubicek, Milos Husak, Vit Baisa
        write(u'''
''')
        _orig_filter_42566843 = _filter
        filterName = u'WebSafe'
        if self._CHEETAH__filters.has_key("WebSafe"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''

<table id="full_ref">
''')
        for r in VFFSL(SL,"Refs",True): # generated from line 7, col 1
            if not VFFSL(SL,"hidenone",True) or (VFFSL(SL,"r.val",True) and VFFSL(SL,"r.val",True) != '===NONE==='): # generated from line 8, col 3
                write(u'''    <tr><td><b>''')
                _v = VFFSL(SL,"r.name",True) # u'$r.name' on line 9, col 16
                if _v is not None: write(_filter(_v, rawExpr=u'$r.name')) # from line 9, col 16.
                write(u'''</b></td><td>
''')
                if VFN(VFFSL(SL,"r.val",True),"startswith",False)('http://'): # generated from line 10, col 5
                    write(u'''      <a href="''')
                    _v = VFFSL(SL,"r.val",True) # u'$r.val' on line 11, col 16
                    if _v is not None: write(_filter(_v, rawExpr=u'$r.val')) # from line 11, col 16.
                    write(u'''" target="_blank">''')
                    _v = VFFSL(SL,"r.val",True) # u'$r.val' on line 11, col 40
                    if _v is not None: write(_filter(_v, rawExpr=u'$r.val')) # from line 11, col 40.
                    write(u'''</a>
''')
                else: # generated from line 12, col 5
                    write(u'''      ''')
                    _v = VFFSL(SL,"r.val",True) # u'$r.val' on line 13, col 7
                    if _v is not None: write(_filter(_v, rawExpr=u'$r.val')) # from line 13, col 7.
                    write(u'''
''')
            write(u'''  </td></tr>
''')
        write(u'''</table>
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_42566843
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_fullref= 'respond'

## END CLASS DEFINITION

if not hasattr(fullref, '_initCheetahAttributes'):
    templateAPIClass = getattr(fullref, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(fullref)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=fullref()).run()


