#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1476103984.157932
__CHEETAH_genTimestamp__ = 'Mon Oct 10 14:53:04 2016'
__CHEETAH_src__ = 'templates/savecoll.tmpl'
__CHEETAH_srcLastModified__ = 'Wed Jan 20 17:24:23 2016'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class savecoll(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(savecoll, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        #  Copyright (c) 2003-2015  Pavel Rychly, Vojtech Kovar, Milos Jakubicek, Milos Husak, Vit Baisa
        #  XML format
        if VFFSL(SL,"saveformat",True) == 'xml': # generated from line 4, col 1
            write(u'''<?xml version="1.0" encoding="''')
            _v = VFFSL(SL,"corpencoding",True) # u'$corpencoding' on line 5, col 31
            if _v is not None: write(_filter(_v, rawExpr=u'$corpencoding')) # from line 5, col 31.
            write(u'''"?>

''')
            _orig_filter_30762045 = _filter
            filterName = u'WebSafe'
            if self._CHEETAH__filters.has_key("WebSafe"):
                _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
            else:
                _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
            write(u'''<collocations>
''')
            if VFFSL(SL,"heading",True): # generated from line 9, col 3
                write(u'''  <heading>
    <corpus>''')
                _v = VFFSL(SL,"corpname",True) # u'$corpname' on line 11, col 13
                if _v is not None: write(_filter(_v, rawExpr=u'$corpname')) # from line 11, col 13.
                write(u'''</corpus>
''')
                if VFFSL(SL,"usesubcorp",True): # generated from line 12, col 5
                    write(u'''      <subcorpus>''')
                    _v = VFFSL(SL,"usesubcorp",True) # u'$usesubcorp' on line 13, col 18
                    if _v is not None: write(_filter(_v, rawExpr=u'$usesubcorp')) # from line 13, col 18.
                    write(u'''</subcorpus>
''')
                write(u'''    <query>''')
                for d in VFFSL(SL,"Desc",True): # generated from line 16, col 5
                    _v = VFFSL(SL,"d.arg",True) # u'$d.arg' on line 17, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$d.arg')) # from line 17, col 1.
                write(u'''</query>
    <scores>
''')
                for s in VFFSL(SL,"Scores",True): # generated from line 22, col 5
                    write(u'''      <score>''')
                    _v = VFFSL(SL,"s.n",True) # u'$s.n' on line 23, col 14
                    if _v is not None: write(_filter(_v, rawExpr=u'$s.n')) # from line 23, col 14.
                    write(u'''</score>
''')
                write(u'''    </scores>
  </heading>
''')
            write(u'''  <items>
''')
            for i in VFFSL(SL,"Items",True): # generated from line 29, col 3
                write(u'''    <item>
      <str>''')
                _v = VFFSL(SL,"i.str",True) # u'$i.str' on line 31, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'$i.str')) # from line 31, col 12.
                write(u'''</str>
      <freq>''')
                _v = VFFSL(SL,"i.freq",True) # u'$i.freq' on line 32, col 13
                if _v is not None: write(_filter(_v, rawExpr=u'$i.freq')) # from line 32, col 13.
                write(u'''</freq>
''')
                for ss in VFFSL(SL,"i.Stats",True): # generated from line 33, col 5
                    write(u'''      <score>''')
                    _v = VFFSL(SL,"ss.s",True) # u'$ss.s' on line 34, col 14
                    if _v is not None: write(_filter(_v, rawExpr=u'$ss.s')) # from line 34, col 14.
                    write(u'''</score>
''')
                write(u'''    </item>
''')
            write(u'''  </items>
</collocations>

''')
            _filter = self._CHEETAH__currentFilter = _orig_filter_30762045
        else: # generated from line 42, col 1
            #  Text format
            if VFFSL(SL,"heading",True): # generated from line 44, col 3
                write(u'''# ''')
                if False:
                    _('Collocations')
                _v = VFFSL(SL,"_",False)('Collocations') # u"$_('Collocations')" on line 45, col 4
                if _v is not None: write(_filter(_v, rawExpr=u"$_('Collocations')")) # from line 45, col 4.
                write(u'''\r
# ''')
                if False:
                    _('Corpus')
                _v = VFFSL(SL,"_",False)('Corpus') # u"$_('Corpus')" on line 46, col 4
                if _v is not None: write(_filter(_v, rawExpr=u"$_('Corpus')")) # from line 46, col 4.
                write(u''': ''')
                _v = VFFSL(SL,"corp_full_name",True) # u'$corp_full_name' on line 46, col 18
                if _v is not None: write(_filter(_v, rawExpr=u'$corp_full_name')) # from line 46, col 18.
                write(u'''\r
''')
                if VFFSL(SL,"usesubcorp",True): # generated from line 47, col 5
                    write(u'''# ''')
                    if False:
                        _('Subcorpus')
                    _v = VFFSL(SL,"_",False)('Subcorpus') # u"$_('Subcorpus')" on line 48, col 4
                    if _v is not None: write(_filter(_v, rawExpr=u"$_('Subcorpus')")) # from line 48, col 4.
                    write(u''': ''')
                    _v = VFFSL(SL,"usesubcorp",True) # u'$usesubcorp' on line 48, col 21
                    if _v is not None: write(_filter(_v, rawExpr=u'$usesubcorp')) # from line 48, col 21.
                    write(u'''\r
''')
                for d in VFFSL(SL,"Desc",True): # generated from line 50, col 5
                    write(u'''# ''')
                    _v = VFFSL(SL,"d.op",True) # u'$d.op' on line 51, col 4
                    if _v is not None: write(_filter(_v, rawExpr=u'$d.op')) # from line 51, col 4.
                    write(u''':  ''')
                    _v = VFFSL(SL,"d.arg",True) # u'$d.arg' on line 51, col 12
                    if _v is not None: write(_filter(_v, rawExpr=u'$d.arg')) # from line 51, col 12.
                    write(u''' ''')
                    _v = VFFSL(SL,"d.size",True) # u'$d.size' on line 51, col 19
                    if _v is not None: write(_filter(_v, rawExpr=u'$d.size')) # from line 51, col 19.
                    write(u'''\r
''')
                write(u'''\r
''')
            for h in VFFSL(SL,"Head",True): # generated from line 55, col 3
                _v = VFFSL(SL,"h.n",True) # u'$h.n' on line 56, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$h.n')) # from line 56, col 1.
                write(u'''\t''')
            write(u'''\r
''')
            for i in VFFSL(SL,"Items",True): # generated from line 59, col 1
                _v = VFFSL(SL,"i.str",True) # u'$i.str' on line 60, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'$i.str')) # from line 60, col 1.
                write(u'''\t''')
                _v = VFFSL(SL,"i.freq",True) # u'$i.freq' on line 60, col 8
                if _v is not None: write(_filter(_v, rawExpr=u'$i.freq')) # from line 60, col 8.
                write(u'''\t''')
                for ss in VFFSL(SL,"i.Stats",True): # generated from line 61, col 3
                    _v = VFFSL(SL,"ss.s",True) # u'$ss.s' on line 62, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'$ss.s')) # from line 62, col 1.
                    write(u'''\t''')
                write(u'''\r
''')
            write(u'''\r
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_savecoll= 'respond'

## END CLASS DEFINITION

if not hasattr(savecoll, '_initCheetahAttributes'):
    templateAPIClass = getattr(savecoll, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(savecoll)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=savecoll()).run()


