#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1476103984.077268
__CHEETAH_genTimestamp__ = 'Mon Oct 10 14:53:04 2016'
__CHEETAH_src__ = 'templates/savefreq.tmpl'
__CHEETAH_srcLastModified__ = 'Wed Jan 20 17:24:23 2016'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class savefreq(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(savefreq, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        #  Copyright (c) 2003-2015  Pavel Rychly, Vojtech Kovar, Milos Husak, Vit Baisa
        if VFFSL(SL,"saveformat",True) == 'xml': # generated from line 3, col 1
            _orig_filter_84276779 = _filter
            filterName = u'WebSafe'
            if self._CHEETAH__filters.has_key("WebSafe"):
                _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
            else:
                _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
            #  XML
            write(u'''<?xml version="1.0" encoding="''')
            _v = VFFSL(SL,"corpencoding",True) # u'$corpencoding' on line 6, col 31
            if _v is not None: write(_filter(_v, rawExpr=u'$corpencoding')) # from line 6, col 31.
            write(u'''"?>

<frequency>
''')
            if VFFSL(SL,"heading",True): # generated from line 9, col 1
                write(u'''  <heading>
    <corpus>''')
                _v = VFFSL(SL,"corpname",True) # u'$corpname' on line 11, col 13
                if _v is not None: write(_filter(_v, rawExpr=u'$corpname')) # from line 11, col 13.
                write(u'''</corpus>
''')
                if VFFSL(SL,"usesubcorp",True): # generated from line 12, col 3
                    write(u'''    <subcorpus>''')
                    _v = VFFSL(SL,"usesubcorp",True) # u'$usesubcorp' on line 13, col 16
                    if _v is not None: write(_filter(_v, rawExpr=u'$usesubcorp')) # from line 13, col 16.
                    write(u'''</subcorpus>
''')
                write(u'''    <query>''')
                for d in VFFSL(SL,"Desc",True): # generated from line 16, col 5
                    _v = VFN(VFFSL(SL,"d",True),"get",False)('arg') # u"$d.get('arg')" on line 17, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u"$d.get('arg')")) # from line 17, col 1.
                write(u'''</query>
  </heading>
''')
            for b in VFFSL(SL,"Blocks",True): # generated from line 23, col 3
                write(u'''  <block>
    <name>''')
                _v = VFFSL(SL,"b.blockname",True) # u'$b.blockname' on line 25, col 11
                if _v is not None: write(_filter(_v, rawExpr=u'$b.blockname')) # from line 25, col 11.
                write(u'''</name>
    <items>
''')
                for i in VFFSL(SL,"b.Items",True): # generated from line 27, col 7
                    write(u'''      <item>
''')
                    for w in VFFSL(SL,"i.Word",True): # generated from line 29, col 9
                        write(u'''          <str>''')
                        _v = VFFSL(SL,"w.n",True) # u'$w.n' on line 30, col 16
                        if _v is not None: write(_filter(_v, rawExpr=u'$w.n')) # from line 30, col 16.
                        write(u'''</str>
''')
                    write(u'''          <freq>''')
                    _v = VFFSL(SL,"i.freq",True) # u'$i.freq' on line 32, col 17
                    if _v is not None: write(_filter(_v, rawExpr=u'$i.freq')) # from line 32, col 17.
                    write(u'''</freq>
''')
                    if not (VFFSL(SL,"ml",True)):
                        write(u'''          <rel>''')
                        _v = VFFSL(SL,"i.rel",True) # u'$i.rel' on line 34, col 16
                        if _v is not None: write(_filter(_v, rawExpr=u'$i.rel')) # from line 34, col 16.
                        write(u'''</rel>
''')
                    if VFFSL(SL,"examples",True): # generated from line 36, col 9
                        write(u'''          <example>''')
                        _v = VFN(VFFSL(SL,"i",True),"get",False)('example', '') # u"$i.get('example', '')" on line 37, col 20
                        if _v is not None: write(_filter(_v, rawExpr=u"$i.get('example', '')")) # from line 37, col 20.
                        write(u'''</example>
''')
                    write(u'''      </item>
''')
                write(u'''    </items>
  </block>
''')
            write(u'''</frequency>

''')
            _filter = self._CHEETAH__currentFilter = _orig_filter_84276779
        else: # generated from line 47, col 1
            #  text
            if VFFSL(SL,"heading",True): # generated from line 49, col 1
                write(u'''# Frequency list\r
\r
# Corpus: ''')
                _v = VFFSL(SL,"corpname",True) # u'$corpname' on line 52, col 12
                if _v is not None: write(_filter(_v, rawExpr=u'$corpname')) # from line 52, col 12.
                write(u'''\r
''')
                if VFFSL(SL,"usesubcorp",True): # generated from line 53, col 3
                    write(u'''# Subcorpus: ''')
                    _v = VFFSL(SL,"usesubcorp",True) # u'$usesubcorp' on line 54, col 15
                    if _v is not None: write(_filter(_v, rawExpr=u'$usesubcorp')) # from line 54, col 15.
                    write(u'''\r
''')
                for d in VFFSL(SL,"Desc",True): # generated from line 56, col 3
                    write(u'''# ''')
                    _v = VFN(VFFSL(SL,"d",True),"get",False)('op') # u"$d.get('op')" on line 57, col 4
                    if _v is not None: write(_filter(_v, rawExpr=u"$d.get('op')")) # from line 57, col 4.
                    write(u''':  ''')
                    _v = VFN(VFFSL(SL,"d",True),"get",False)('arg') # u"$d.get('arg')" on line 57, col 19
                    if _v is not None: write(_filter(_v, rawExpr=u"$d.get('arg')")) # from line 57, col 19.
                    write(u''' ''')
                    _v = VFN(VFFSL(SL,"d",True),"get",False)('size') # u"$d.get('size')" on line 57, col 33
                    if _v is not None: write(_filter(_v, rawExpr=u"$d.get('size')")) # from line 57, col 33.
                    write(u'''\r
''')
                write(u'''\r
# Frequency limit: ''')
                _v = VFFSL(SL,"flimit",True) # u'$flimit' on line 60, col 21
                if _v is not None: write(_filter(_v, rawExpr=u'$flimit')) # from line 60, col 21.
                write(u'''\r
\r
''')
            for b in VFFSL(SL,"Blocks",True): # generated from line 63, col 1
                write(u'''\r
''')
                for h in VFFSL(SL,"b.Head",True): # generated from line 65, col 3
                    _v = VFN(VFFSL(SL,"h",True),"get",False)('n') # u"$h.get('n')" on line 66, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u"$h.get('n')")) # from line 66, col 1.
                    write(u'''\t''')
                write(u'''\r
-------------------------------------------------------\r
''')
                for i in VFFSL(SL,"b.Items",True): # generated from line 70, col 3
                    for w in VFFSL(SL,"i.Word",True): # generated from line 71, col 5
                        _v = VFN(VFFSL(SL,"w",True),"get",False)('n') # u"$w.get('n')" on line 72, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u"$w.get('n')")) # from line 72, col 1.
                        write(u'''\t''')
                    _v = VFN(VFFSL(SL,"i",True),"get",False)('freq') # u"$i.get('freq')" on line 74, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u"$i.get('freq')")) # from line 74, col 1.
                    write(u'''\t''')
                    if not (VFFSL(SL,"ml",True)):
                        _v = VFN(VFFSL(SL,"i",True),"get",False)('rel') # u"$i.get('rel')" on line 76, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u"$i.get('rel')")) # from line 76, col 1.
                        write(u'''\t''')
                    if VFFSL(SL,"examples",True): # generated from line 78, col 2
                        _v = VFN(VFFSL(SL,"i",True),"get",False)('example', '') # u"$i.get('example', '')" on line 79, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u"$i.get('example', '')")) # from line 79, col 1.
                        write(u'''\t''')
                    write(u'''\r
''')
            write(u'''\r
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_savefreq= 'respond'

## END CLASS DEFINITION

if not hasattr(savefreq, '_initCheetahAttributes'):
    templateAPIClass = getattr(savefreq, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(savefreq)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=savefreq()).run()


