#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
try:
    import builtins as builtin
except ImportError:
    import __builtin__ as builtin
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.4'
__CHEETAH_versionTuple__ = (2, 4, 4, 'development', 0)
__CHEETAH_genTime__ = 1476103984.345735
__CHEETAH_genTimestamp__ = 'Mon Oct 10 14:53:04 2016'
__CHEETAH_src__ = 'templates/savewl.tmpl'
__CHEETAH_srcLastModified__ = 'Thu Sep  8 12:21:53 2016'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class savewl(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(savewl, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def display_nested_ngram_txt(self, ngram, sep='\t', level=0, **KWS):



        ## CHEETAH: generated from #def display_nested_ngram_txt($ngram, $sep='\t', $level=0) at line 2, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        for i in VFFSL(SL,"range",False)(VFFSL(SL,"level",True)): # generated from line 3, col 3
            write(u''' ... ''')
        if VFFSL(SL,"level",True): # generated from line 6, col 3
            write(u''' ''')
            _v = VFFSL(SL,"ngram.str",True) # u'${ngram.str}' on line 7, col 2
            if _v is not None: write(_filter(_v, rawExpr=u'${ngram.str}')) # from line 7, col 2.
            _v = VFFSL(SL,"sep",True) # u'${sep}' on line 7, col 14
            if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 7, col 14.
            _v = VFFSL(SL,"ngram.freq",True) # u'${ngram.freq}' on line 7, col 20
            if _v is not None: write(_filter(_v, rawExpr=u'${ngram.freq}')) # from line 7, col 20.
            write(u'''\r
''')
        for ch in VFFSL(SL,"ngram.children",True): # generated from line 9, col 3
            _orig_filter_16591066 = _filter
            _filter = self._CHEETAH__initialFilter
            write(u'''      ''')
            _v = VFFSL(SL,"display_nested_ngram_txt",False)(VFFSL(SL,"ch",True), VFFSL(SL,"sep",True), level+1) # u'$display_nested_ngram_txt($ch, $sep, level+1)' on line 11, col 7
            if _v is not None: write(_filter(_v, rawExpr=u'$display_nested_ngram_txt($ch, $sep, level+1)')) # from line 11, col 7.
            _filter = self._CHEETAH__currentFilter = _orig_filter_16591066
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def display_nested_ngram_xml(self, ngram, first=1, **KWS):



        ## CHEETAH: generated from #def display_nested_ngram_xml($ngram, $first=1) at line 15, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        if not VFN(VFFSL(SL,"ngram",True),"get",False)('nested', '') or not VFFSL(SL,"first",True): # generated from line 17, col 3
            write(u'''    <item>
      <str>''')
            _v = VFFSL(SL,"ngram.str",True) # u'$ngram.str' on line 19, col 12
            if _v is not None: write(_filter(_v, rawExpr=u'$ngram.str')) # from line 19, col 12.
            write(u'''</str>
      <freq>''')
            _v = VFFSL(SL,"ngram.freq",True) # u'$ngram.freq' on line 20, col 13
            if _v is not None: write(_filter(_v, rawExpr=u'$ngram.freq')) # from line 20, col 13.
            write(u'''</freq>
''')
            for ch in VFFSL(SL,"ngram.children",True): # generated from line 21, col 5
                _orig_filter_34567589 = _filter
                _filter = self._CHEETAH__initialFilter
                write(u'''        ''')
                _v = VFFSL(SL,"display_nested_ngram_xml",False)(VFFSL(SL,"ch",True), 0) # u'$display_nested_ngram_xml($ch, 0)' on line 23, col 9
                if _v is not None: write(_filter(_v, rawExpr=u'$display_nested_ngram_xml($ch, 0)')) # from line 23, col 9.
                write(u'''
''')
                _filter = self._CHEETAH__currentFilter = _orig_filter_34567589
            write(u'''    </item>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        #  Copyright (c) 2003-2013  Pavel Rychly, Vojtech Kovar, Milos Husak, Vit Baisa
        if VFFSL(SL,"saveformat",True) == 'xml': # generated from line 30, col 1
            _orig_filter_97736532 = _filter
            filterName = u'WebSafe'
            if self._CHEETAH__filters.has_key("WebSafe"):
                _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
            else:
                _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
            #  XML format
            write(u"""<?xml version='1.0' encoding='""")
            _v = VFFSL(SL,"corpencoding",True) # u'$corpencoding' on line 33, col 31
            if _v is not None: write(_filter(_v, rawExpr=u'$corpencoding')) # from line 33, col 31.
            write(u"""'?>

<word_list>
""")
            if VFFSL(SL,"heading",True): # generated from line 36, col 1
                write(u'''  <heading>
    <corpus>''')
                _v = VFFSL(SL,"corpname",True) # u'$corpname' on line 38, col 13
                if _v is not None: write(_filter(_v, rawExpr=u'$corpname')) # from line 38, col 13.
                write(u'''</corpus>
''')
                if VFFSL(SL,"usesubcorp",True): # generated from line 39, col 3
                    write(u'''    <subcorpus>''')
                    _v = VFFSL(SL,"usesubcorp",True) # u'$usesubcorp' on line 40, col 16
                    if _v is not None: write(_filter(_v, rawExpr=u'$usesubcorp')) # from line 40, col 16.
                    write(u'''</subcorpus>
''')
                if VFFSL(SL,"Keywords",True): # generated from line 42, col 3
                    write(u'''    <ref_corpus>''')
                    _v = VFFSL(SL,"ref_corpname",True) # u'$ref_corpname' on line 43, col 17
                    if _v is not None: write(_filter(_v, rawExpr=u'$ref_corpname')) # from line 43, col 17.
                    write(u'''</ref_corpus>
''')
                    if VFFSL(SL,"ref_usesubcorp",True): # generated from line 44, col 5
                        write(u'''    <ref_subcorpus>''')
                        _v = VFFSL(SL,"ref_usesubcorp",True) # u'$ref_usesubcorp' on line 45, col 20
                        if _v is not None: write(_filter(_v, rawExpr=u'$ref_usesubcorp')) # from line 45, col 20.
                        write(u'''</ref_subcorpus>
''')
                write(u'''  </heading>
''')
            if VFFSL(SL,"Items",True): # generated from line 50, col 1
                write(u'''  <items attr="''')
                _v = VFFSL(SL,"wlattr",True) # u'$wlattr' on line 51, col 16
                if _v is not None: write(_filter(_v, rawExpr=u'$wlattr')) # from line 51, col 16.
                write(u'''">
''')
                for i in VFFSL(SL,"Items",True): # generated from line 52, col 3
                    if VFFSL(SL,"usengrams",True) and VFFSL(SL,"nest_ngrams",True): # generated from line 53, col 5
                        _orig_filter_77120996 = _filter
                        _filter = self._CHEETAH__initialFilter
                        write(u'''        ''')
                        _v = VFFSL(SL,"display_nested_ngram_xml",False)(VFFSL(SL,"i",True)) # u'$display_nested_ngram_xml($i)' on line 55, col 9
                        if _v is not None: write(_filter(_v, rawExpr=u'$display_nested_ngram_xml($i)')) # from line 55, col 9.
                        write(u'''
''')
                        _filter = self._CHEETAH__currentFilter = _orig_filter_77120996
                        continue
                    write(u'''    <item>
''')
                    if VFFSL(SL,"wlattr",True) == 'ws_terms': # generated from line 60, col 5
                        write(u'''      <str>''')
                        _v = VFN(VFFSL(SL,"i.w2",True),"replace",False)('_', ' ') # u"$i.w2.replace('_', ' ')" on line 61, col 12
                        if _v is not None: write(_filter(_v, rawExpr=u"$i.w2.replace('_', ' ')")) # from line 61, col 12.
                        write(u'''</str>
''')
                    else: # generated from line 62, col 5
                        write(u'''      <str>''')
                        _v = VFFSL(SL,"i.str",True) # u'$i.str' on line 63, col 12
                        if _v is not None: write(_filter(_v, rawExpr=u'$i.str')) # from line 63, col 12.
                        write(u'''</str>
''')
                    write(u'''      <freq>''')
                    _v = VFFSL(SL,"i.freq",True) # u'$i.freq' on line 65, col 13
                    if _v is not None: write(_filter(_v, rawExpr=u'$i.freq')) # from line 65, col 13.
                    write(u'''</freq>
''')
                    if VFFSL(SL,"wlattr",True) == 'ws_collocations': # generated from line 66, col 5
                        write(u'''      <score>''')
                        _v = VFFSL(SL,"i.score",True) # u'$i.score' on line 67, col 14
                        if _v is not None: write(_filter(_v, rawExpr=u'$i.score')) # from line 67, col 14.
                        write(u'''</score>
''')
                    write(u'''    </item>
''')
                write(u'''  </items>
''')
            else: # generated from line 72, col 1
                if VFFSL(SL,"Keywords",True): # generated from line 73, col 1
                    write(u'''  <items attr="''')
                    _v = VFFSL(SL,"wlattr",True) # u'$wlattr' on line 74, col 16
                    if _v is not None: write(_filter(_v, rawExpr=u'$wlattr')) # from line 74, col 16.
                    write(u'''">
''')
                    for k in VFFSL(SL,"Keywords",True): # generated from line 75, col 3
                        write(u'''    <item>
''')
                        if VFFSL(SL,"wlattr",True) == 'ws_terms': # generated from line 77, col 5
                            write(u'''      <str>''')
                            _v = VFN(VFFSL(SL,"k.str",True),"split",False)('\t')[2].replace('_', ' ') # u"${k.str.split('\\t')[2].replace('_', ' ')}" on line 78, col 12
                            if _v is not None: write(_filter(_v, rawExpr=u"${k.str.split('\\t')[2].replace('_', ' ')}")) # from line 78, col 12.
                            write(u'''</str>
''')
                        else: # generated from line 79, col 5
                            write(u'''      <str>''')
                            _v = VFFSL(SL,"k.str",True) # u'$k.str' on line 80, col 12
                            if _v is not None: write(_filter(_v, rawExpr=u'$k.str')) # from line 80, col 12.
                            write(u'''</str>
''')
                        write(u'''      <freq>''')
                        _v = VFFSL(SL,"k.freq",True) # u'$k.freq' on line 82, col 13
                        if _v is not None: write(_filter(_v, rawExpr=u'$k.freq')) # from line 82, col 13.
                        write(u'''</freq>
      <rel>''')
                        _v = VFFSL(SL,"k.rel",True) # u'$k.rel' on line 83, col 12
                        if _v is not None: write(_filter(_v, rawExpr=u'$k.rel')) # from line 83, col 12.
                        write(u'''</rel>
      <freq_ref>''')
                        _v = VFN(VFFSL(SL,"k",True),"get",False)('freq_ref', '0') # u"$k.get('freq_ref', '0')" on line 84, col 17
                        if _v is not None: write(_filter(_v, rawExpr=u"$k.get('freq_ref', '0')")) # from line 84, col 17.
                        write(u'''</freq_ref>
      <rel_ref>''')
                        _v = VFN(VFFSL(SL,"k",True),"get",False)('rel_ref', '0') # u"$k.get('rel_ref', '0')" on line 85, col 16
                        if _v is not None: write(_filter(_v, rawExpr=u"$k.get('rel_ref', '0')")) # from line 85, col 16.
                        write(u'''</rel_ref>
      <score>''')
                        _v = VFFSL(SL,"k.score",True) # u'$k.score' on line 86, col 14
                        if _v is not None: write(_filter(_v, rawExpr=u'$k.score')) # from line 86, col 14.
                        write(u'''</score>
    </item>
''')
                    write(u'''</items>
''')
            write(u'''</word_list>

''')
            _filter = self._CHEETAH__currentFilter = _orig_filter_97736532
        else: # generated from line 95, col 1
            sep = '	'
            if VFFSL(SL,"saveformat",True) == 'csv': # generated from line 97, col 3
                sep = ','
            write(u'''
''')
            if VFFSL(SL,"heading",True): # generated from line 101, col 1
                write(u'''# Word list\r
\r
# Corpus:    ''')
                _v = VFFSL(SL,"corpname",True) # u'$corpname' on line 104, col 15
                if _v is not None: write(_filter(_v, rawExpr=u'$corpname')) # from line 104, col 15.
                write(u'''\r
''')
                if VFFSL(SL,"usesubcorp",True): # generated from line 105, col 3
                    write(u'''# Subcorpus: ''')
                    _v = VFFSL(SL,"usesubcorp",True) # u'$usesubcorp' on line 106, col 15
                    if _v is not None: write(_filter(_v, rawExpr=u'$usesubcorp')) # from line 106, col 15.
                    write(u'''\r
''')
                if VFFSL(SL,"Keywords",True): # generated from line 108, col 3
                    write(u'''# Reference corpus:    ''')
                    _v = VFFSL(SL,"ref_corpname",True) # u'$ref_corpname' on line 109, col 25
                    if _v is not None: write(_filter(_v, rawExpr=u'$ref_corpname')) # from line 109, col 25.
                    write(u'''\r
''')
                    if VFFSL(SL,"ref_usesubcorp",True): # generated from line 110, col 5
                        write(u'''# Reference subcorpus: ''')
                        _v = VFFSL(SL,"ref_usesubcorp",True) # u'$ref_usesubcorp' on line 111, col 25
                        if _v is not None: write(_filter(_v, rawExpr=u'$ref_usesubcorp')) # from line 111, col 25.
                        write(u'''\r
''')
                write(u'''\r
''')
            write(u'''\r
''')
            if VFFSL(SL,"Items",True): # generated from line 117, col 1
                _v = VFFSL(SL,"wlattr",True) # u'${wlattr}' on line 118, col 1
                if _v is not None: write(_filter(_v, rawExpr=u'${wlattr}')) # from line 118, col 1.
                _v = VFFSL(SL,"sep",True) # u'${sep}' on line 118, col 10
                if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 118, col 10.
                write(u'''Freq\r
------------------------------\r
''')
                for i in VFFSL(SL,"Items",True): # generated from line 120, col 3
                    if VFFSL(SL,"wlattr",True) == 'ws_terms': # generated from line 121, col 5
                        _v = VFN(VFFSL(SL,"i.w2",True),"replace",False)('_', ' ') # u"${i.w2.replace('_', ' ')}" on line 122, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u"${i.w2.replace('_', ' ')}")) # from line 122, col 1.
                        _v = VFFSL(SL,"sep",True) # u'${sep}' on line 122, col 26
                        if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 122, col 26.
                        _v = VFFSL(SL,"i.freq",True) # u'$i.freq' on line 122, col 32
                        if _v is not None: write(_filter(_v, rawExpr=u'$i.freq')) # from line 122, col 32.
                        write(u'''\r
''')
                    elif VFFSL(SL,"wlattr",True) == 'ws_collocations': # generated from line 123, col 5
                        _v = VFFSL(SL,"i.str",True) # u'${i.str}' on line 124, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'${i.str}')) # from line 124, col 1.
                        _v = VFFSL(SL,"sep",True) # u'${sep}' on line 124, col 9
                        if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 124, col 9.
                        _v = VFFSL(SL,"i.freq",True) # u'$i.freq' on line 124, col 15
                        if _v is not None: write(_filter(_v, rawExpr=u'$i.freq')) # from line 124, col 15.
                        _v = VFFSL(SL,"sep",True) # u'${sep}' on line 124, col 22
                        if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 124, col 22.
                        _v = VFFSL(SL,"i.score",True) # u'$i.score' on line 124, col 28
                        if _v is not None: write(_filter(_v, rawExpr=u'$i.score')) # from line 124, col 28.
                        write(u'''\r
''')
                    else: # generated from line 125, col 5
                        if VFFSL(SL,"usengrams",True) and VFFSL(SL,"nest_ngrams",True) and VFN(VFFSL(SL,"i",True),"get",False)('nested', ''): # generated from line 126, col 7
                            continue
                        _v = VFFSL(SL,"i.str",True) # u'${i.str}' on line 129, col 1
                        if _v is not None: write(_filter(_v, rawExpr=u'${i.str}')) # from line 129, col 1.
                        _v = VFFSL(SL,"sep",True) # u'${sep}' on line 129, col 9
                        if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 129, col 9.
                        _v = VFFSL(SL,"i.freq",True) # u'$i.freq' on line 129, col 15
                        if _v is not None: write(_filter(_v, rawExpr=u'$i.freq')) # from line 129, col 15.
                        write(u'''\r
''')
                        if VFFSL(SL,"usengrams",True) and VFFSL(SL,"nest_ngrams",True) and VFN(VFFSL(SL,"i",True),"get",False)('children', []): # generated from line 130, col 7
                            _v = VFFSL(SL,"display_nested_ngram_txt",False)(VFFSL(SL,"i",True), VFFSL(SL,"sep",True)) # u'$display_nested_ngram_txt($i, $sep)' on line 131, col 1
                            if _v is not None: write(_filter(_v, rawExpr=u'$display_nested_ngram_txt($i, $sep)')) # from line 131, col 1.
                            write(u'''
''')
            else: # generated from line 135, col 1
                write(u'''\r
''')
                if VFFSL(SL,"Keywords",True): # generated from line 137, col 3
                    _v = VFFSL(SL,"wlattr",True) # u'${wlattr}' on line 138, col 1
                    if _v is not None: write(_filter(_v, rawExpr=u'${wlattr}')) # from line 138, col 1.
                    _v = VFFSL(SL,"sep",True) # u'${sep}' on line 138, col 10
                    if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 138, col 10.
                    write(u'''Freq''')
                    _v = VFFSL(SL,"sep",True) # u'${sep}' on line 138, col 20
                    if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 138, col 20.
                    write(u'''Freq/mill''')
                    _v = VFFSL(SL,"sep",True) # u'${sep}' on line 138, col 35
                    if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 138, col 35.
                    write(u'''Freq_ref''')
                    _v = VFFSL(SL,"sep",True) # u'${sep}' on line 138, col 49
                    if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 138, col 49.
                    write(u'''Freq_ref/mill''')
                    _v = VFFSL(SL,"sep",True) # u'${sep}' on line 138, col 68
                    if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 138, col 68.
                    write(u'''Score\r
----------------------------------------------------------------------------------\r
''')
                    for k in VFFSL(SL,"Keywords",True): # generated from line 140, col 5
                        if VFFSL(SL,"wlattr",True) == 'ws_terms': # generated from line 141, col 7
                            _v = VFN(VFFSL(SL,"k.str",True),"split",False)('\t')[2].replace('_', ' ') # u"${k.str.split('\\t')[2].replace('_', ' ')}" on line 142, col 1
                            if _v is not None: write(_filter(_v, rawExpr=u"${k.str.split('\\t')[2].replace('_', ' ')}")) # from line 142, col 1.
                            _v = VFFSL(SL,"sep",True) # u'${sep}' on line 142, col 42
                            if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 142, col 42.
                            _v = VFFSL(SL,"k.freq",True) # u'$k.freq' on line 142, col 48
                            if _v is not None: write(_filter(_v, rawExpr=u'$k.freq')) # from line 142, col 48.
                            _v = VFFSL(SL,"sep",True) # u'${sep}' on line 142, col 55
                            if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 142, col 55.
                            _v = VFFSL(SL,"k.rel",True) # u'$k.rel' on line 142, col 61
                            if _v is not None: write(_filter(_v, rawExpr=u'$k.rel')) # from line 142, col 61.
                            _v = VFFSL(SL,"sep",True) # u'${sep}' on line 142, col 67
                            if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 142, col 67.
                            _v = VFN(VFFSL(SL,"k",True),"get",False)('freq_ref', '0') # u"$k.get('freq_ref', '0')" on line 142, col 73
                            if _v is not None: write(_filter(_v, rawExpr=u"$k.get('freq_ref', '0')")) # from line 142, col 73.
                            _v = VFFSL(SL,"sep",True) # u'${sep}' on line 142, col 96
                            if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 142, col 96.
                            _v = VFN(VFFSL(SL,"k",True),"get",False)('rel_ref', '0') # u"$k.get('rel_ref', '0')" on line 142, col 102
                            if _v is not None: write(_filter(_v, rawExpr=u"$k.get('rel_ref', '0')")) # from line 142, col 102.
                            _v = VFFSL(SL,"sep",True) # u'${sep}' on line 142, col 124
                            if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 142, col 124.
                            _v = VFFSL(SL,"k.score",True) # u'$k.score' on line 142, col 130
                            if _v is not None: write(_filter(_v, rawExpr=u'$k.score')) # from line 142, col 130.
                            write(u'''\r
''')
                        else: # generated from line 143, col 7
                            _v = VFFSL(SL,"k.str",True) # u'$k.str' on line 144, col 1
                            if _v is not None: write(_filter(_v, rawExpr=u'$k.str')) # from line 144, col 1.
                            _v = VFFSL(SL,"sep",True) # u'${sep}' on line 144, col 7
                            if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 144, col 7.
                            _v = VFFSL(SL,"k.freq",True) # u'$k.freq' on line 144, col 13
                            if _v is not None: write(_filter(_v, rawExpr=u'$k.freq')) # from line 144, col 13.
                            _v = VFFSL(SL,"sep",True) # u'${sep}' on line 144, col 20
                            if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 144, col 20.
                            _v = VFFSL(SL,"k.rel",True) # u'$k.rel' on line 144, col 26
                            if _v is not None: write(_filter(_v, rawExpr=u'$k.rel')) # from line 144, col 26.
                            _v = VFFSL(SL,"sep",True) # u'${sep}' on line 144, col 32
                            if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 144, col 32.
                            _v = VFN(VFFSL(SL,"k",True),"get",False)('freq_ref', '0') # u"$k.get('freq_ref', '0')" on line 144, col 38
                            if _v is not None: write(_filter(_v, rawExpr=u"$k.get('freq_ref', '0')")) # from line 144, col 38.
                            _v = VFFSL(SL,"sep",True) # u'${sep}' on line 144, col 61
                            if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 144, col 61.
                            _v = VFN(VFFSL(SL,"k",True),"get",False)('rel_ref', '0') # u"$k.get('rel_ref', '0')" on line 144, col 67
                            if _v is not None: write(_filter(_v, rawExpr=u"$k.get('rel_ref', '0')")) # from line 144, col 67.
                            _v = VFFSL(SL,"sep",True) # u'${sep}' on line 144, col 89
                            if _v is not None: write(_filter(_v, rawExpr=u'${sep}')) # from line 144, col 89.
                            _v = VFFSL(SL,"k.score",True) # u'$k.score' on line 144, col 95
                            if _v is not None: write(_filter(_v, rawExpr=u'$k.score')) # from line 144, col 95.
                            write(u'''\r
''')
            write(u'''\r
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_savewl= 'respond'

## END CLASS DEFINITION

if not hasattr(savewl, '_initCheetahAttributes'):
    templateAPIClass = getattr(savewl, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(savewl)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=savewl()).run()


